# ABsolute PRIority COUnter (abpricou) #

abpricou parses Java source code and counts its mass as defined by the
Absolute Priority Premise. It is written in Python and has the awesome
[plyj](https://github.com/musiKk/plyj) and [PLY](https://github.com/dabeaz/ply)
as its sole dependencies.

## Absolute Priority Premise ##

In 2012 Micah Martin defined some heuristics to objectively say, "This
code is better than that code." Building on [Uncle Bob's Transformation
Priority Premise](https://blog.8thlight.com/uncle-bob/2013/05/27/TheTransformationPriorityPremise.html)
he defined six components, i.e. basic building blocks of code, and
assigned them a mass. The total mass of a piece of code is the sum of
the mass of its respective components. A lower value is better.

A detailed explanation of the Absolute Priority Premise is given in
the two presentations of 8th Light University (8LU) -
[Part One](https://vimeo.com/57851350) and
[Part Two](https://vimeo.com/59265614). See also
[Micah's Coin Changer Kata](http://blog.8thlight.com/micah-martin/2012/11/17/transformation-priority-premise-applied.html)
as a complete example of applying the premise.

### Limitations ###
* abpricou currently supports Java 7 due to limitations of plyj.
* I developed it to count the mass of a specific set of classes. No 
  exhaustive tests have been done. If you find something that us not
  counted, please get in touch.
* I was interested in the mass of algorithms, so class constructs
  like class definitions are ignored. Probably a class definition is
  a constant (for the code) and a binding (for the name). Also enums
  and all annotations as well as generics were ignored.
* Counting mass depends on opinion. You may count different. If so,
  please get in touch.

### Example ###
I used abpricou to compare different implementations of Word Wrap kata 
in my blog post
[Absolute Priority Premise, an Example](http://blog.code-cop.org/2016/08/absolute-priority-premise-example.html).

### License ###
abpricou's license is the
[New BSD License](http://opensource.org/licenses/bsd-license.php),
see `license.txt` in this repository. Both plyj and PLY are also BSD
licensed.